package frc.robot.subsystems;

import java.util.function.DoubleSupplier;

import com.ctre.phoenix.motorcontrol.VictorSPXControlMode;
import com.ctre.phoenix.motorcontrol.can.VictorSPX;

import edu.wpi.first.wpilibj2.command.Command;
import edu.wpi.first.wpilibj2.command.SubsystemBase;
import frc.robot.constants.ClimberConstants;

public class Climber extends SubsystemBase {
    private VictorSPX motor1;
    private VictorSPX motor2;

    private DoubleSupplier shooterAngle;

    //TODO What tells the climber to stop climbing when it achieves the target height?
    public Climber(DoubleSupplier shooterAngle) {
        if(shooterAngle.getAsDouble() > Math.toRadians(-10.0)){
            motor1 = new VictorSPX(ClimberConstants.kClimberMotor1CANID);
            motor2 = new VictorSPX(ClimberConstants.kClimberMotor2CANID);

            motor2.follow(motor1);
        }
    }

    public Command setSpeedWithSupplier(DoubleSupplier speed) {
        return run(() -> {

            if(shooterAngle.getAsDouble() > Math.toRadians(-10.0)){
                motor1.set(VictorSPXControlMode.PercentOutput, speed.getAsDouble());
            }
        });
    }

    public Command setSpeed(double speed) {
        return run(() -> {
            motor1.set(VictorSPXControlMode.PercentOutput, speed);
        });
    }

    public Command stop() {
        return setSpeed(0);
    }
}
